Loading...
Searching...
No Matches
DefaultModel Class Reference

Default charge model for file-provided atomic charges. More...

`#include <avogadro/calc/defaultmodel.h>`

Inheritance diagram for DefaultModel:

## Public Member Functions

| DefaultModel (const std::string &identifier="")
DefaultModel * | newInstance () const override
std::string | identifier () const override
| A unique identifier defined by the file.
virtual void | setIdentifier (const std::string &identifier)
| Set the identifier.
std::string | name () const override
| We don't have any other name beyond the identifier in the file.
Core::Molecule::ElementMask | elements () const override
| This default method is defined for whatever is in a molecule.
MatrixX | partialCharges (Core::Molecule &mol) const override
| Retrieve the relevant charges from the molecule for our defined type.
MatrixX | partialCharges (const Core::Molecule &mol) const override
Public Member Functions inherited from ChargeModel
virtual void | setDielectric (float dielectric)
virtual float | dielectric () const
virtual Vector3 | dipoleMoment (const Core::Molecule &mol) const
| Calculate the dipole moment of the molecule.
virtual double | potential (Core::Molecule &mol, const Vector3 &point) const
| Calculate the electrostatic potential at a particular point in space.
virtual Core::Array< double > | potentials (Core::Molecule &mol, const Core::Array< Vector3 > &points) const
| Calculate the electrostatic potential at multiple points.

## Protected Attributes

std::string | m_identifier
Core::Molecule::ElementMask | m_elements

## Additional Inherited Members

Protected Member Functions inherited from ChargeModel
void | appendError (const std::string &errorString, bool newLine=true) const
| Append an error to the error string for the model.

## Detailed Description

Author
  Geoffrey R. Hutchison

This is a default model for using atomic partial charges from a file (e.g., quantum chemistry packages often provide Mulliken charges)

The class

## Member Function Documentation

## newInstance()

DefaultModel * newInstance | ( |  | ) | const

override virtual

Create a new instance of the file format class. Ownership passes to the caller.

Implements ChargeModel.

## identifier()

std::string identifier | ( |  | ) | const

override virtual

Implements ChargeModel.

## name()

std::string name | ( |  | ) | const

override virtual

Implements ChargeModel.

## elements()

Core::Molecule::ElementMask elements | ( |  | ) | const

override virtual

Returns
  all elements - technically not true, but we don't have the mol

Implements ChargeModel.

## partialCharges() [1/2]

MatrixX partialCharges | ( | Core::Molecule & | mol | ) | const

override virtual

Implements ChargeModel.

## partialCharges() [2/2]

MatrixX partialCharges | ( | const Core::Molecule & | mol | ) | const

override virtual

Implements ChargeModel.

The documentation for this class was generated from the following file:

- defaultmodel.h